      subroutine get_functions(p3,p4,qph,fun)
* Cross section is binned in nbin bins differentiated in these functions
      include 'shared.inc'
      include 'nbin.inc'
      dimension bmi(ndistr),bma(ndistr),fun(ndistr)      
      double precision qa(0:3),qb(0:3),qw(0:3)
      double precision pippo(0:3),pluto(0:3),topolino(0:3)
      common/fordebugging/idebugging
      common/bmibma/bmi,bma
      common/getfunfirst/ifirst
      data ifirst /1/
      if (ifirst.eq.1) then
         do k = 1,ndistr
            bmi(k) = 0.d0
            bma(k) = 1.d0
            fun(k) = 0.5d0
         enddo
      endif
c------------------------------------
      egmin = 3.d0
      if (ifirst.eq.1) then
         bmi(1) =   25.d0
         bma(1) =   50.d0
         bmi(2) =   40.d0
         bma(2) =   65.d0
         bmi(3) =   50.d0
         bma(3) =   500.d0
         bmi(4) =   25.d0
         bma(4) =   50.d0
         bmi(5) =   40.d0
         bma(5) =   65.d0
         bmi(6) =   50.d0
         bma(6) =   500.d0
         bmi(7) =  2.d0* bmi(1)
         bma(7) =  2.d0* bma(1)
         bmi(8) =  2.d0* bmi(2)
         bma(8) =  2.d0* bma(2)
         bmi(9) =  2.d0* bmi(3)
         bma(9) =  2.d0* bma(3)
         bmi(10) = -etamax
         bma(10) =  etamax
         bmi(11) = -10.d0
         bma(11) =  10.d0
         bmi(12) = -2.d0*etamax
         bma(12) =  2.d0*etamax
         bmi(13) = -0.1d0
         bma(13) =  50.d0
         bmi(14) = -0.1d0
         bma(14) = 50.d0
         bmi(15) = -0.1d0
         bma(15) = 50.d0
         bmi(16) = -0.5d0
         bma(16) = 10.5d0
         bmi(17) = bmi(16)
         bma(17) = bma(16)
         bmi(18) = 0.d0
         bma(18) = 180.d0
         bmi(19) = 50.d0
         bma(19) = 110.d0
         bmi(20) = -etamax
         bma(20) =  etamax
      endif
      fun(1) = sqrt(p3(1)**2 + p3(2)**2)
      fun(2) = fun(1)
      fun(3) = fun(1)
      fun(4) = sqrt(p4(1)**2 + p4(2)**2)
      fun(5) = fun(4)
      fun(6) = fun(4)

      pippo(3) = 0.d0
      pluto(3) = 0.d0
      do k = 1,2
         pippo(k) = p3(k)
         pluto(k) = p4(k)
      enddo
      pippo(0) = fun(1)
      pluto(0) = fun(4)
      do k = 0,3
         topolino(k) = pippo(k) + pluto(k)
      enddo
      tmass2 = abs(dot(topolino,topolino))
      fun(7)  = sqrt(tmass2)      

      fun(8) = fun(7)
      fun(9) = fun(7)

      do k = 0,3
         topolino(k) = p3(k)+p4(k)
      enddo
      fun(19) = sqrt(dot(topolino,topolino))

      fun(10) = rapidity(p3)
      fun(11) = rapidity(p4)

      fun(12) = rapidity(topolino)

      fun(13) = (p3(1)+p4(1))**2 + (p3(2)+p4(2))**2
      fun(13) = sqrt(fun(13))
      call fotonepiuenergetico(qph,qa)
      fun(14) = bmi(14) - 1.d0
      fun(15) = bmi(15) - 1.d0
      fun(18) = bmi(18) - 1.d0
      fun(20) = bmi(20) - 1.d0

      ptg = sqrt(qa(1)**2+qa(2)**2)
      ag = -5d0
      etag = 1000d0

c      print*,qa

      if (qa(0).gt.egmin) then
         ctg = qa(3) / qa(0)
         if (abs(ctg)-1.d0.gt.0.d0) then 
            ctg  = ctg - ctg/abs(ctg)*1.d-10
         endif
         ag  = acos(ctg)*180.d0/pi
         etag = rapidity(qa)
         fun(14) = ptg
         if (abs(etag).lt.etamax) then 
            fun(15) = ptg
            fun(20) = etag
         endif
         fun(18) = ag
      endif

      fun(16) = -10
      fun(17) = -10
      call countphotons(qph,egmin,etamax,n1,n2)
      fun(16) = n1
      fun(17) = n2

      ifirst = 0
      return
      end
*********************************************************************      
      subroutine setfilesnames
      include 'shared.inc'
      include 'nbin.inc'
      character*150 filesnames(ndistr),afbfile,afbtotfile,tmpname
      character*30  distname(ndistr)
      character*8   distorder,accel,bins,recom
      common/aawrite/ifirst_write,filesnames
      common/write_distributions_extra/afbfile,afbtotfile

      call resetname(tmpname)
      do k = 1,ndistr
         filesnames(k) = tmpname
         distname(k) = tmpname
      enddo
      afbfile = tmpname
      afbtotfile = tmpname
      distorder = tmpname
      accel = tmpname
      bins = tmpname
      recom = tmpname

      if (irec.eq.1) recom='rec_'
      if (irec.eq.0) recom='norec_'

** filling name of distribution files...
      if (charge_factor(3).lt.0.5d0) then 
         distorder='born.dat'
      else
         if (qedorder.eq.'exp')   distorder='best.dat'
         if (qedorder.eq.'alpha') distorder='oal1.dat'
      endif
      
      if (hadr1.eq.hadr2) accel='lhc_'
      if (hadr1.ne.hadr2) accel='tev_'
      if (i_pdf.eq.0)     accel='pl_'
      
      do k = 1,100
         if (path(k:k).ne.' ') lpath=k
      enddo
      do k = 1,ndistr
         call merge_strings(path,'empty_distr.dat',filesnames(k))
      enddo
      call merge_strings(path,'afb_',afbfile)
      call merge_strings(afbfile,distorder,afbfile)
      call merge_strings(path,'afbtot_',afbtotfile)
      call merge_strings(afbtotfile,distorder,afbtotfile)
***
      if (boson.eq.'OLD W DISTRIBUTIONS') then         
      else  ! if boson eq Z or W (new DISTRIBUTIONS!)
         call resetname(distorder)
         call resetname(afbfile)
         call resetname(afbtotfile)

         if (charge_factor(3).lt.0.5d0) then 
            distorder='born_'
         else
            if (qedorder.eq.'exp')   distorder='best_'
            if (qedorder.eq.'alpha') distorder='oal_'
         endif
         call itoa(nbin,bins)

         distname(1)  = 'ptl1_'
         distname(2)  = 'ptl2_'
         distname(3)  = 'ptl3_'
         distname(4)  = 'ptn1_'
         distname(5)  = 'ptn2_'
         distname(6)  = 'ptn3_'
         distname(7)  = 'mtw1_'
         distname(8)  = 'mtw2_'
         distname(9)  = 'mtw3_'
         distname(10) = 'etal_'
         distname(11) = 'etan_'
         distname(12) = 'yw_'
         distname(13) = 'ptw_'
         distname(14) = 'ptg1_'
         distname(15) = 'ptg2_'
         distname(16) = 'ng1_'
         distname(17) = 'ng2_'
         distname(18) = 'ag_'
         distname(19) = 'minv_'
         distname(20) = 'etag_'

         do k = 1,ndistr
            call resetname(tmpname)
            call merge_strings(path,tmpname,tmpname)
            call merge_strings(tmpname,accel,tmpname)

            if (boson.eq.'Z') call merge_strings(tmpname,'z_',tmpname)
            if (boson.eq.'W') call merge_strings(tmpname,'w_',tmpname)

            if (lepton.eq.1) call merge_strings(tmpname,'el_',tmpname)
            if (lepton.eq.2) call merge_strings(tmpname,'mu_',tmpname)
            call merge_strings(tmpname,distname(k),tmpname)
            call merge_strings(tmpname,distorder,tmpname)
            call merge_strings(tmpname,recom,tmpname)
            call merge_strings(tmpname,bins,tmpname)
            call merge_strings(tmpname,'.dat',tmpname)
            filesnames(k) = tmpname
         enddo

         call merge_strings(path,afbfile,afbfile)
         call merge_strings(path,afbtotfile,afbtotfile)
         call merge_strings(afbfile,accel,afbfile)
         call merge_strings(afbtotfile,accel,afbtotfile)
         call merge_strings(afbfile,'afb_',afbfile)
         call merge_strings(afbtotfile,'afbtot_',afbtotfile)
         if (lepton.eq.1) call merge_strings(afbfile,'el_',afbfile)
         if (lepton.eq.2) call merge_strings(afbfile,'mu_',afbfile)
         if (lepton.eq.1) 
     >        call merge_strings(afbtotfile,'el_',afbtotfile)
         if (lepton.eq.2) 
     >        call merge_strings(afbtotfile,'mu_',afbtotfile)

         call merge_strings(afbfile,distorder,afbfile)
         call merge_strings(afbtotfile,distorder,afbtotfile)
         call merge_strings(afbfile,recom,afbfile)
         call merge_strings(afbtotfile,recom,afbtotfile)
         call merge_strings(afbfile,bins,afbfile)
         call merge_strings(afbtotfile,bins,afbtotfile)
         call merge_strings(afbfile,'.dat',afbfile)
         call merge_strings(afbtotfile,'.dat',afbtotfile)
*****
      endif
      return
      end
*****************************************************
      subroutine resetname(name)
      integer i
      character*(*) name
      do i = 1,len(name)
         name(i:i) = ' '
      enddo
      return
      end
**
      function ifirstemptychar(name)
      integer i,k
      character*(*) name
      i = 1
      do k = 1,len(name)
         if (name(k:k).ne.' ') i=k
      enddo
      ifirstemptychar = i ! + 1
      return
      end
**
      subroutine merge_strings(str1,str2,merged)
      character*(*) merged,str1,str2
      integer n1
      n1 = ifirstemptychar(str1)
      if (str1(n1:n1).eq.' ') then
         merged=str2
      else
         merged=str1(:n1)//str2
      endif
      return
      end
**
      subroutine itoa(int,a)
      implicit integer (h-n)
      implicit character (a-g)
      character*(*) a
      parameter (nbase=10)

      call resetname(a)
      ichar0 = ichar('0')
      idiv = nbase
      i    = int
      ncifre    = 1
      do while((i/idiv).gt.0)
         idiv = idiv * nbase
         ncifre = ncifre+1
      enddo
      idiv = idiv/nbase

      do k =1,ncifre
         icifra = i/idiv
         ia = icifra + ichar0
         a(k:k) = char(ia)
         i = i - icifra*idiv
         idiv = idiv/nbase
      enddo      
      return
      end
************************************************+
      subroutine fptoa(d,a)
      implicit integer (h-n)
      double precision d,dec,tmp
      character*(*) a
      character*30 adec
      parameter (ndecimali=1000000000)
      parameter (nbase=10)

      intpart = d
      call itoa(intpart,a)

      dec = d-intpart
      idecimali = dec*ndecimali

      tmp = intpart
      tmp = tmp*ndecimali
      tmp = tmp + idecimali

      if (anint(d*ndecimali-tmp).gt.0) idecimali = idecimali + 1

      call itoa(idecimali,adec)

      nleadzeri = 0
      i = 1
      icont = 1
      ictrl = 0
      do while(i.lt.ndecimali.and.idecimali.gt.0)
         i = i*nbase
         ictrl = dec * i - ictrl
         if (ictrl.ge.1) icont = 0
         if (ictrl.eq.0) nleadzeri = nleadzeri + 1*icont
      enddo

      ladec = len(adec)
      istop = 0
      do k=1,ladec
         i = ladec+1 - k
         if (adec(i:i).ne.' ') then
            if (adec(i:i).ne.'0') istop = 1
            if (adec(i:i).eq.'0'.and.istop.eq.0) adec(i:i)=''
         endif
      enddo
      
      call merge_strings(a,'.',a)

      if (nleadzeri.gt.0) then
         do k=1,nleadzeri
            call merge_strings(a,'0',a)
         enddo
      endif

      call merge_strings(a,adec,a)
      return
      end
*****************************************************
      subroutine distributions(sd,nc,p3,p4,qph)
      include 'shared.inc'
      include 'nbin.inc'
      common/distr/distr,s_distr
      common/bmibma/bmi,bma
      common/fordebugging/idebugging
      common/ionlyfirsttime/ifirst
      data ifirst /0/ 
      dimension s_distr(ndistr,ibin)
      dimension distr(ndistr,ibin),bmi(ndistr),bma(ndistr),fun(ndistr)
      data ((distr(i,j),i=1,ndistr),j=1,ibin) /iperj * 0.d0/	
      data ((s_distr(i,j),i=1,ndistr),j=1,ibin) /iperj * 0.d0/	
      integer*8 nc
      call get_functions(p3,p4,qph,fun)
***********************************************************************
***********************************************************************
! filling distr. components when entering the first time
      if (ifirst.eq.0) then
         do k = 1,ndistr
            d = (bma(k) - bmi(k))/nbin
            y = bmi(k)
            do i = 1,nbin
               y = y + d
               distr(k,i*3-2)   = y - d
               s_distr(k,i*3-2) = y - d
            enddo
         enddo
      endif
***************************************
      DO k = 1,ndistr
         bmax = bma(k)
         d = (bma(k) - bmi(k))/nbin
         x = bmi(k)
** OLD ***
c$$$         i_stop = 0
c$$$         i      = 0
c$$$         if (fun(k).lt.bmi(k).or.fun(k).gt.bma(k)) i_stop = 1
c$$$         do while(i_stop.eq.0)
c$$$            i = i + 3
c$$$            x = x + d
c$$$            if (fun(k).lt.x.and.fun(k).gt.bmi(k)) then
c$$$               distr(k,i-1) = distr(k,i-1) + sd
c$$$               distr(k,i)   = distr(k,i)   + sd**2
c$$$               su  = distr(k,i-1)
c$$$               su2 = distr(k,i)
c$$$               s_distr(k,i-1) = su / nc
c$$$           argument = abs((su2/nc-s_distr(k,i-1)**2)/nc)
c$$$               s_distr(k,i) = sqrt(argument)
c$$$               i_stop   = 1
c$$$            endif
c$$$            if (x.ge.bmax) i_stop = 1
c$$$         enddo
c$$$         ibck = i
** OLD ***
** NEW ***
         if (fun(k).lt.bma(k).and.fun(k).gt.bmi(k)) then
            i  = (fun(k) - bmi(k))/d
            i  = (i+1)*3

            distr(k,i-1) = distr(k,i-1) + sd
            distr(k,i)   = distr(k,i)   + sd**2
            su  = distr(k,i-1)
            su2 = distr(k,i)
            s_distr(k,i-1) = su / nc
            argument = abs((su2/nc-s_distr(k,i-1)**2)/nc)
            s_distr(k,i) = sqrt(argument)
         endif
** NEW ***
      ENDDO
      ifirst = 1          
      return
      end
*********************************************************************
      subroutine writedistributions
      include 'shared.inc'
      include 'nbin.inc'
      dimension s_distr(ndistr,ibin),bmi(ndistr),bma(ndistr)
      dimension distr(ndistr,ibin)
      real*4 xplot(nbin),yplot(nbin)
      character*150 filesnames(ndistr),afbfile,afbtotfile
      common/aawrite/ifirst_write,filesnames
      common/write_distributions_extra/afbfile,afbtotfile
      common/distr/distr,s_distr
      common/bmibma/bmi,bma
*
      data ifirst_write /1/
*****
      if (ifirst_write.eq.1) then 
         call setfilesnames
      endif
*****      
      do k = 1,ndistr       
         open(12,file=filesnames(k),status='unknown')
         do i=1,nbin
            sezd  = s_distr(k,i*3-1) /(bma(k)-bmi(k))*nbin   !!! /1000.d0 directely in pb!
            esezd = s_distr(k,i*3) /(bma(k)-bmi(k))*nbin     !!! /1000.d0
            write(12,*)s_distr(k,i*3-2),sezd,esezd
c            if (k.eq.1) then
c               xplot(i) = s_distr(k,i*3-2)
c               yplot(i) = sezd
c            endif
	 enddo
         close(12)
      enddo
*********
* per avere le "distribuzioni" in asimmetria devo usare le distribuzioni
* 11 e 12.....
c$$$      sezf  = 0.d0
c$$$      sezb  = 0.d0
c$$$      esezf = 0.d0
c$$$      esezb = 0.d0
c$$$      open(12,file=afbfile,status='unknown')
c$$$      do i=1,nbin
c$$$         sezf  = sezf+s_distr(11,i*3-1)
c$$$         sezb  = sezb+s_distr(12,i*3-1)
c$$$         esezf = esezf+s_distr(11,i*3)
c$$$         esezb = esezb+s_distr(12,i*3)
c$$$         anum  = s_distr(11,i*3-1) - s_distr(12,i*3-1)
c$$$         den   = s_distr(11,i*3-1) + s_distr(12,i*3-1)
c$$$         enum  = s_distr(11,i*3) + s_distr(12,i*3)
c$$$         eden  = enum
c$$$         sezd  = 0.d0
c$$$         esezd = 0.d0
c$$$         if (den.gt.0.d0.and.abs(anum).gt.0.d0) then
c$$$            sezd  = anum/den
c$$$            esezd = sqrt(enum**2/anum**2+eden**2/den**2)*sezd
c$$$         endif
c$$$         write(12,*)s_distr(12,i*3-2),sezd,esezd
c$$$      enddo
c$$$      close(12)
c$$$
c$$$      anum = (sezf-sezb)
c$$$      den = (sezf+sezb)
c$$$
c$$$      afbtot = 0.d0
c$$$      eafbtot = 0.d0
c$$$      if (den.gt.0.d0.and.abs(anum).gt.0.d0) then
c$$$         afbtot = anum / den
c$$$      endif
c$$$      enum = esezf+esezb
c$$$      eden = esezf+esezb
c$$$      if (den.gt.0.d0.and.abs(anum).gt.0.d0) then
c$$$         eafbtot=sqrt(enum**2/anum**2+eden**2/den**2)*afbtot
c$$$      endif
c$$$      open(12,file=afbtotfile,status='unknown')
c$$$      write(12,*)'total Afb =',afbtot,' +-',eafbtot
c$$$      close(12)
*********
* PLOTTING via fifo with gnuplot at runtime!! use gnuplot < fifoplot
c      iplot = 3
c      if (ifirst_write.eq.1) open(30,file='fifoplot',status='unknown')
c      write(30,*)'plot ''1.dat'', ''2.dat'''
c      call flush(30)
*********
      ifirst_write = 0
      return
      end
*************************************************
      subroutine fotonepiuenergetico(q,q1)
! written by CMCC, last modified 9/10/2005
      implicit real*8 (a-h,o-z)
      dimension q(40,0:3),q1(0:3)
*  LEADING ENERGETIC PHOTON IS EXTRACTED
      q1(0) = 0.d0
      q1(1) = 0.d0
      q1(2) = 0.d0
      q1(3) = 0.d0

ccc      if (q(1,0).lt.1.d-11) return
C for backward compatibility with old ps-based BABAYAGA
c      if (q(1,0).lt.1.d-11.and.q(11,0).lt.0.d0.and.
c     .     q(21,0).lt.1.d-11.and.q(31,0).lt.0.d0) return

      ENHARD = 0.d0
      J=1
*
      DO I = 1,40
         if (q(i,0).gt.0.d0) then
            ENPHOT = Q(I,0)
            IF (ENHARD.GE.ENPHOT) THEN
               ENHARD = ENHARD
            ELSE
               J = I
               ENHARD = ENPHOT
            ENDIF
         endif
      ENDDO
*
      if (enhard.gt.0.d0) then
         DO I = 0,3
            Q1(I) = Q(J,I)
         ENDDO
      endif
      return
      end
***************************

      subroutine duefotonipiuenergetici(q,q1,q2)
      implicit double precision (a-h,o-z)
      dimension q(40,0:3),q1(0:3),q2(0:3)
* 
*  leading energetic photon is extracted
*
        do i = 0,3
           q1(i) = 0.d0
           q2(i) = 0.d0
        enddo

        sum = 0.d0
	do k=1,40
          sum = sum + q(k,0)
        enddo
        if (sum.lt.1.d-8) return

        enphot = q(1,0)
        enhard = enphot
        j=1
* 
        do i = 1,40
           enphot = q(i,0)
           if (enhard.ge.enphot) then
              enhard = enhard
           else
              j = i
              enhard = enphot
           endif
        enddo 
*   
        enhardl = enhard
        jl = j
*
        if (j.gt.0) then
           do i = 0,3
              q1(i) = q(j,i)
           enddo
        endif
*  next-to-leading energetic photon is extracted
      enhard = 0.d0
      j = 0
      do i = 1,40
         if (i.ne.jl) then
            enphot = q(i,0)
            if (enhard.ge.enphot) then
               enhard = enhard
            else
               j = i
               enhard = enphot
            endif
         endif
      enddo 
*   
      enhard = enhard
      if (j.gt.0) then
         do i = 0,3
            q2(i) = q(j,i)
         enddo
      endif
      return
      end


*********************************************
*********************************************
*********************************************
*********************************************************************      
      subroutine setfilesnames2
      include 'shared.inc'
      include 'nbin2.inc'
      character*150 filesnames(ndistr),afbfile,afbtotfile,tmpname
      character*30  distname(ndistr)
      character*8   distorder,accel,bins,recom
      common/write_distributions2/ifirst_write,filesnames
      common/write_distributions_extra2/afbfile,afbtotfile

      call resetname(tmpname)
      do k = 1,ndistr
         filesnames(k) = tmpname
         distname(k) = tmpname
      enddo
      afbfile = tmpname
      afbtotfile = tmpname
      distorder = tmpname
      accel = tmpname
      bins = tmpname
      recom = tmpname

      if (irec.eq.1) recom='rec_'
      if (irec.eq.0) recom='norec_'

** filling name of distribution files...
      if (charge_factor(3).lt.0.5d0) then 
         distorder='born.dat'
      else
         if (qedorder.eq.'exp')   distorder='best.dat'
         if (qedorder.eq.'alpha') distorder='oal1.dat'
      endif
      
      if (hadr1.eq.hadr2) accel='lhc_'
      if (hadr1.ne.hadr2) accel='tev_'
      if (i_pdf.eq.0)     accel='pl_'
      
      do k = 1,100
         if (path(k:k).ne.' ') lpath=k
      enddo
      do k = 1,ndistr
         call merge_strings(path,'empty_distr.dat',filesnames(k))
      enddo
      call merge_strings(path,'afb_',afbfile)
      call merge_strings(afbfile,distorder,afbfile)
      call merge_strings(path,'afbtot_',afbtotfile)
      call merge_strings(afbtotfile,distorder,afbtotfile)
***

         call resetname(distorder)
         call resetname(afbfile)
         call resetname(afbtotfile)

         if (charge_factor(3).lt.0.5d0) then 
            distorder='born_'
         else
            if (qedorder.eq.'exp')   distorder='best_'
            if (qedorder.eq.'alpha') distorder='oal_'
         endif
         call itoa(nbin,bins)


         distname(1)  = 'ptl1_'
         distname(2)  = 'ptl2_'
         distname(3)  = 'ptl3_'
         distname(4)  = 'ptn1_'
         distname(5)  = 'ptn2_'
         distname(6)  = 'ptn3_'
         distname(7)  = 'mtw1_'
         distname(8)  = 'mtw2_'
         distname(9)  = 'mtw3_'
         distname(10) = 'etal_'
         distname(11) = 'etan_'
         distname(12) = 'yw_'
         distname(13) = 'ptw_'
         distname(14) = 'ptg1_'
         distname(15) = 'ptg2_'
         distname(16) = 'ng1_'
         distname(17) = 'ng2_'
         distname(18) = 'ag_'
         distname(19) = 'minv_'
         distname(20) = 'etag_'



         do k = 1,ndistr
            call resetname(tmpname)
            call merge_strings(path,tmpname,tmpname)
            call merge_strings(tmpname,accel,tmpname)

            if (boson.eq.'Z') call merge_strings(tmpname,'z_',tmpname)
            if (boson.eq.'W') call merge_strings(tmpname,'w_',tmpname)

            if (lepton.eq.1) call merge_strings(tmpname,'el_',tmpname)
            if (lepton.eq.2) call merge_strings(tmpname,'mu_',tmpname)
            call merge_strings(tmpname,distname(k),tmpname)
            call merge_strings(tmpname,distorder,tmpname)
            call merge_strings(tmpname,recom,tmpname)
            call merge_strings(tmpname,bins,tmpname)
            call merge_strings(tmpname,'.dat',tmpname)
            filesnames(k) = tmpname
         enddo




         call merge_strings(path,afbfile,afbfile)
         call merge_strings(path,afbtotfile,afbtotfile)
         call merge_strings(afbfile,accel,afbfile)
         call merge_strings(afbtotfile,accel,afbtotfile)
         call merge_strings(afbfile,'afb_',afbfile)
         call merge_strings(afbtotfile,'afbtot_',afbtotfile)
         if (lepton.eq.1) call merge_strings(afbfile,'el_',afbfile)
         if (lepton.eq.2) call merge_strings(afbfile,'mu_',afbfile)
         if (lepton.eq.1) 
     >        call merge_strings(afbtotfile,'el_',afbtotfile)
         if (lepton.eq.2) 
     >        call merge_strings(afbtotfile,'mu_',afbtotfile)

         call merge_strings(afbfile,distorder,afbfile)
         call merge_strings(afbtotfile,distorder,afbtotfile)
         call merge_strings(afbfile,recom,afbfile)
         call merge_strings(afbtotfile,recom,afbtotfile)
         call merge_strings(afbfile,bins,afbfile)
         call merge_strings(afbtotfile,bins,afbtotfile)
         call merge_strings(afbfile,'.dat',afbfile)
         call merge_strings(afbtotfile,'.dat',afbtotfile)
*****

      return
      end
*****************************************************
*********************************************************************
      subroutine writedistributions2
      include 'shared.inc'
      include 'nbin2.inc'
      dimension s_distr(ndistr,ibin),bmi(ndistr),bma(ndistr)
      dimension distr(ndistr,ibin)
      real*4 xplot(nbin),yplot(nbin)
      character*150 filesnames(ndistr),afbfile,afbtotfile
      common/write_distributions2/ifirst_write,filesnames
      common/write_distributions_extra2/afbfile,afbtotfile
      common/distr2/distr,s_distr
      common/bmibma/bmi,bma
*
      data ifirst_write /1/
*****
      if (ifirst_write.eq.1) then 
         call setfilesnames2
      endif
*****      
      do k = 1,ndistr       
         open(12,file=filesnames(k),status='unknown')
         do i=1,nbin
            sezd  = s_distr(k,i*3-1) /(bma(k)-bmi(k))*nbin    !!! /1000.d0
            esezd = s_distr(k,i*3) /(bma(k)-bmi(k))*nbin      !!! /1000.d0
            write(12,*)s_distr(k,i*3-2),sezd,esezd
c            if (k.eq.1) then
c               xplot(i) = s_distr(k,i*3-2)
c               yplot(i) = sezd
c            endif
	 enddo
         close(12)
      enddo
      ifirst_write = 0
      return
      end
*************************************************
      subroutine distributions2(sd,nc,p3,p4,qph)
      include 'shared.inc'
      include 'nbin2.inc'
      common/distr2/distr,s_distr
      common/bmibma/bmi,bma
      common/ionlyfirsttime2/ifirst
      
      data ifirst /0/ 
      dimension s_distr(ndistr,ibin)
      dimension distr(ndistr,ibin),bmi(ndistr),bma(ndistr),fun(ndistr)

      data ((distr(i,j),i=1,ndistr),j=1,ibin) /iperj * 0.d0/	
      data ((s_distr(i,j),i=1,ndistr),j=1,ibin) /iperj * 0.d0/	
      integer*8 nc

      call get_functions(p3,p4,qph,fun)
***

***********************************************************************
***********************************************************************
! filling distr. components when entering the first time
      if (ifirst.eq.0) then
         do k = 1,ndistr
            d = (bma(k) - bmi(k))/nbin
            y = bmi(k)
            do i = 1,nbin
               y = y + d
               distr(k,i*3-2)   = y - d
               s_distr(k,i*3-2) = y - d
            enddo
         enddo
      endif

***************************************
      DO k = 1,ndistr
         bmax = bma(k)
         d = (bma(k) - bmi(k))/nbin
         x = bmi(k)
** NEW ***
         if (fun(k).lt.bma(k).and.fun(k).gt.bmi(k)) then
            i  = (fun(k) - bmi(k))/d
            i  = (i+1)*3

            distr(k,i-1) = distr(k,i-1) + sd
            distr(k,i)   = distr(k,i)   + sd**2
            su  = distr(k,i-1)
            su2 = distr(k,i)
            s_distr(k,i-1) = su / nc
            argument = abs((su2/nc-s_distr(k,i-1)**2)/nc)
            s_distr(k,i) = sqrt(argument)
         endif
** NEW ***
      ENDDO
      ifirst = 1          
      return
      end
